#include "keyboard.h"

int ShiftKeyDown; // Shift Key Down?

unsigned int FetchScancode()
{
	return( inportb(0x60)); // port 0x60: get scan code from the keyboard
}

unsigned int FetchAndAnalyzeScancode()
{
	unsigned int scancode; // For getting the keyboard raw scancode
	while(1) // Loop until a key to be pressed
	{
		// Wait for the key
		while ( !(inportb(0x64)&1) ); // 0x64: read keyboard C status register
		scancode = FetchScancode();

		if ( scancode & 0x80 ) // Key released? Check bit 7 (10000000b = 0x80) of scan code for this
		{
			scancode &= 0x7F; // Key was released, compare only low seven bits: 01111111b = 0x7F
			if ( scancode == KRLEFT_SHIFT || scancode == KRRIGHT_SHIFT ) // A key was released, shift key up?
			    ShiftKeyDown = 0;	// yes, it is up --> NonShift
			continue;	// Loop
		}

        // Key was pressed. Capture scan code of shift key, if pressed
		if ( scancode == KRLEFT_SHIFT || scancode == KRRIGHT_SHIFT )
		{
			ShiftKeyDown = 1; // It is down, use asciiShift characters
			continue; // Loop, so it will not return a scan code for the shift key
		}
		return scancode;
	}
}

unsigned char const k_getch() // Scancode --> ASCII
{
	unsigned int scan;		  // scancode from the keyboard
	unsigned char retchar;	  // The chararacter that returns the scan code to ASCII code
	scan = FetchAndAnalyzeScancode(); // Grab scancode, and get the position of the shift key
	if ( ShiftKeyDown )
	    retchar = asciiShift[scan];	// (Upper) Shift Codes
	else
		retchar = asciiNonShift[ scan ]; // (Lower) Non-Shift Codes
	return retchar; // ASCII version
}
